;****** Servo Tester 2
;       ADC include file
;       A/D conversion
;
;       Copyright (c) 2004, Mikael Ejberg Pedersen
;       Only for non-profit use. See a more detailed license
;       description in the user manual or at the Servo Tester 2
;       homepage: http://www.ejberg.dk/servotst2


.dseg

ADCChannel0:            .byte 2
ADCChannel1:            .byte 2

ADCLocalChannel0:       .byte 2
ADCLocalChannel1:       .byte 2
ADCState:               .byte 1


.cseg

ADC_Complete_int:                       ; ADC complete interrupt handler
        push    w1
        in      w1,SREG
        push    w1
        push    w2
        push    w3
        push    w4
        lds     w1,ADCState
        inc     w1
        sts     ADCState,w1
        cpi     w1,1
        breq    ADCC_Exit               ;State 1 Ignore first sample
        cpi     w1,10
        brlo    ADCC_2_9
        breq    ADCC_10
        cpi     w1,13
        brlo    ADCC_Exit               ;State 11-12 Ignore samples
        cpi     w1,21
        brlo    ADCC_13_20
        breq    ADCC_21
        rjmp    ADCC_Exit
ADCC_2_9:                               ;State 2-9 Sample channel 0 8 times (voltage)
        in      w1,ADCL
        in      w2,ADCH
        lds     w3,ADCLocalChannel0
        lds     w4,ADCLocalChannel0+1
        add     w3,w1
        adc     w4,w2
        sts     ADCLocalChannel0,w3
        sts     ADCLocalChannel0+1,w4
        rjmp    ADCC_Exit
ADCC_10:                                ;State 10 Switch to channel 1
        in      w1,ADMUX
        cbr     w1,(1<<MUX4)+(1<<MUX3)+(1<<MUX2)+(1<<MUX1)
        sbr     w1,(1<<MUX0)
        out     ADMUX,w1
        rjmp    ADCC_Exit
ADCC_13_20:                             ;State 13-20 Sample channel 1 8 times (current)
        in      w1,ADCL
        in      w2,ADCH
        lds     w3,ADCLocalChannel1
        lds     w4,ADCLocalChannel1+1
        add     w3,w1
        adc     w4,w2
        sts     ADCLocalChannel1,w3
        sts     ADCLocalChannel1+1,w4
        rjmp    ADCC_Exit
ADCC_21:                                ;State 21 Stop sampling
        in      w1,ADCSRA
        cbr     w1,(1<<ADSC)+(1<<ADATE) ; Stop free running conversion
        out     ADCSRA,w1
        lds     w1,ADCLocalChannel0
        lds     w2,ADCLocalChannel0+1
        sts     ADCChannel0,w1
        sts     ADCChannel0+1,w2
        lds     w1,ADCLocalChannel1
        lds     w2,ADCLocalChannel1+1
        sts     ADCChannel1,w1
        sts     ADCChannel1+1,w2
        ldi     w1,EVENT_ADComplete
        call    EventQ_PutEvent
ADCC_Exit:
        pop     w4
        pop     w3
        pop     w2
        pop     w1
        out     SREG,w1
        pop     w1
        ret


ADC_Init:
        ldi     w1,0            ; Ext AREF, right adj, ADC0 sel
        out     ADMUX,w1
        ldi     w1,(1<<ADEN)+(1<<ADIE)+(1<<ADPS2)+(1<<ADPS1)+(1<<ADPS0)
        out     ADCSRA,w1
        in      w1,SFIOR
        cbr     w1,(1<<ADTS2)+(1<<ADTS1)+(1<<ADTS0)     ;Free running mode
        out     SFIOR,w1
        ret


ADC_StartConversion_All:
        in      w1,DDRA
        cbr     w1,(1<<PA1)+(1<<PA0)
        out     DDRA,w1
        in      w1,PORTA
        cbr     w1,(1<<PA1)+(1<<PA0)
        out     PORTA,w1
        clr     w1
        sts     ADCLocalChannel0,w1
        sts     ADCLocalChannel0+1,w1
        sts     ADCLocalChannel1,w1
        sts     ADCLocalChannel1+1,w1
        sts     ADCState,w1
        in      w1,ADMUX
        cbr     w1,(1<<MUX4)+(1<<MUX3)+(1<<MUX2)+(1<<MUX1)+(1<<MUX0)
        out     ADMUX,w1
        in      w1,ADCSRA
        sbr     w1,(1<<ADSC)+(1<<ADATE)                 ; Start free running conversion
        out     ADCSRA,w1
        ret

