;****** Servo Tester 2
;       Bcklight include file
;       Backlight timing
;
;       Copyright (c) 2004, Mikael Ejberg Pedersen
;       Only for non-profit use. See a more detailed license
;       description in the user manual or at the Servo Tester 2
;       homepage: http://www.ejberg.dk/servotst2


.dseg

BacklightTime:          .byte 1         ;Configurable delay (steps of 10 seconds) (0x00 = no light; 0xff = always light)
BacklightCounter:       .byte 2         ;Internal down counter


.cseg

Backlight_Activity_r01w12:
        lds     w1,BacklightTime
        tst     w1
        breq    BA_TurnOff
        cpi     w1,0xff
        brne    BA_CalcTime
        ser     w1
        ser     w2
        rjmp    BA_StoreTime
BA_CalcTime:
        ldi     w2,100
        mul     w1,w2
        movw    w2:w1,r1:r0
BA_StoreTime:
        sts     BacklightCounter,w1
        sts     BacklightCounter+1,w2
        sbi     PORTC,PC6               ;Backlight on
        rjmp    BA_Exit
BA_TurnOff:
        cbi     PORTC,PC6               ;Backlight off
BA_Exit:
        ret


Backlight_TimerTick_All:
        lds     XL,BacklightCounter
        lds     XH,BacklightCounter+1
        mov     w1,XL
        and     w1,XH
        cpi     w1,0xff
        breq    BTT_Exit                ;Do not count down when counter = 0xffff
        sbiw    XH:XL,1
        sts     BacklightCounter,XL
        sts     BacklightCounter+1,XH
        brne    BTT_Exit                ;Counter hasn't reached 0 yet
        cbi     PORTC,PC6               ;Counter=0 -> Backlight off
BTT_Exit:
        ret


Backlight_Init:
        sbi     DDRC,PC6                ;Backlight pin output
        cbi     PORTC,PC6               ;Backlight off
        clr     w1
        sts     BacklightCounter,w1
        sts     BacklightCounter+1,w1
        ret

