;****** Servo Tester 2
;       Cursor include file
;       Cursor flashing
;
;       Copyright (c) 2004, Mikael Ejberg Pedersen
;       Only for non-profit use. See a more detailed license
;       description in the user manual or at the Servo Tester 2
;       homepage: http://www.ejberg.dk/servotst2


.dseg
CursorStatus:   .byte 1         ;1=Enable cursor
CursorX:        .byte 1         ;Cursor position
CursorY:        .byte 1         ;Cursor position
CursorChar:     .byte 1         ;Char the cursor is made of
CursorCount:    .byte 1         ;Internal counter to time the flashing


.cseg

Cursor_Init:
        clr     w1
        sts     CursorStatus,w1
        ret


;Start flashing the cursor
;w1=X w2=Y w3=FirstChar w4=SecondChar
Cursor_Start:
        push    w1
        sts     CursorX,w1
        sts     CursorY,w2
        call    LCD_GotoXY
        mov     w1,w3
        call    LCD_SendData
        sts     CursorChar,w4
        lds     w1,CursorStatus
        sbr     w1,1
        sts     CursorStatus,w1
        ldi     w1,10
        sts     CursorCount,w1
        pop     w1
        ret


Cursor_Stop:
        clr     w1
        sts     CursorStatus,w1
        ret


Cursor_TimerTick_All:
        lds     w1,CursorStatus
        sbrs    w1,0
        rjmp    CTT_Exit
        lds     w1,CursorCount
        dec     w1
        sts     CursorCount,w1
        brne    CTT_Exit
        ldi     w1,4
        sts     CursorCount,w1
        lds     w1,CursorX
        lds     w2,CursorY
        call    LCD_GotoXY
        call    LCD_ReadData_w1
        lds     w3,CursorChar
        sts     CursorChar,w1
        lds     w1,CursorX
        lds     w2,CursorY
        call    LCD_GotoXY
        mov     w1,w3
        call    LCD_SendData
CTT_Exit:
        ret

