;****** Servo Tester 2
;       Idle include file
;       Idle menu
;
;       Copyright (c) 2004, Mikael Ejberg Pedersen
;       Only for non-profit use. See a more detailed license
;       description in the user manual or at the Servo Tester 2
;       homepage: http://www.ejberg.dk/servotst2


.dseg
IdleValue:              .byte 2


.cseg

Idle_ServiceTable:
        jmp    Idle_Init
        jmp    Idle_DisplayMenu
        jmp    Idle_TakeControl
        jmp    PWIO_Left
        jmp    PWIO_Right
        jmp    PWIO_Push
        jmp    PWIO_UpdateDisplay
        jmp    PWIO_ICP
        jmp    PWIO_TimerTick
        jmp    PWIO_ADComplete
        jmp    PWIO_UpdateCursor
        jmp    PWIO_OutputSent
        jmp    PWIO_TachoUpdate
        jmp    PWIO_Hold


Idle_Init:
        clr     w1
        sts     IdleValue,w1
        sts     IdleValue+1,w1
        ret


Idle_InitPtrs:
        ldi     ZL,low(IdleValue)
        ldi     ZH,high(IdleValue)
        sts     PWIOAddress,ZL
        sts     PWIOAddress+1,ZH
        ldi     ZL,low(2*Idle_Line1)
        ldi     ZH,high(2*Idle_Line1)
        sts     PWIOText1Ptr,ZL
        sts     PWIOText1Ptr+1,ZH
        ldi     w1,Router_Idle
        sts     PWIORouterAdr,w1
        call    PWIO_SetupPWConfigLimit_X
        clr     c2
        ldi     c3,(1<<PWIOC3DisplayAB)
        ret


Idle_DisplayMenu:
        rcall   Idle_InitPtrs
        call    PWIO_BaseDisplay
        ret


Idle_TakeControl:
        rcall   Idle_InitPtrs
        call    PWIO_TakeControl
        ret


Idle_Line1:     .db "  Disable out AB",0,0

