;****** Servo Tester 2
;       Input include file
;       Input menu
;
;       Copyright (c) 2004, Mikael Ejberg Pedersen
;       Only for non-profit use. See a more detailed license
;       description in the user manual or at the Servo Tester 2
;       homepage: http://www.ejberg.dk/servotst2


.dseg
InputValue:             .byte 2         ; Local copy !!!


.cseg

Input_ServiceTable:
        jmp    Input_Init
        jmp    Input_DisplayMenu
        jmp    Input_TakeControl
        jmp    PWIO_Left
        jmp    PWIO_Right
        jmp    PWIO_Push
        jmp    PWIO_UpdateDisplay
        jmp    Input_ICP
        jmp    PWIO_TimerTick
        jmp    PWIO_ADComplete
        jmp    PWIO_UpdateCursor
        jmp    PWIO_OutputSent
        jmp    PWIO_TachoUpdate
        jmp    PWIO_Hold


Input_Init:
        clr     w1
        sts     InputValue,w1
        sts     InputValue+1,w1
        ret


Input_InitPtrs:
        ldi     ZL,low(InputValue)
        ldi     ZH,high(InputValue)
        sts     PWIOAddress,ZL
        sts     PWIOAddress+1,ZH
        ldi     ZL,low(2*Input_Line1)
        ldi     ZH,high(2*Input_Line1)
        sts     PWIOText1Ptr,ZL
        sts     PWIOText1Ptr+1,ZH
        ldi     w1,Router_Input
        sts     PWIORouterAdr,w1
        call    PWIO_SetupPWConfigLimit_X
        clr     c2
        ldi     c3,(1<<PWIOC3DisplayAB)
        ret


Input_DisplayMenu:
        rcall   Input_InitPtrs
        call    PWIO_BaseDisplay
        ret


Input_TakeControl:
        rcall   Input_InitPtrs
        call    PWIO_TakeControl
        ret


Input_ICP:
        ldi     w1,2
        ldi     w2,1
        call    LCD_GotoXY
        lds     XL,InputValue
        lds     XH,InputValue+1
        call    Util_WritePulseWidth_XY
        ret

Input_Line1:    .db "  Input       AB",0,0

