;****** Servo Tester 2
;       Router include file
;       Output router handler
;
;       Copyright (c) 2004, Mikael Ejberg Pedersen
;       Only for non-profit use. See a more detailed license
;       description in the user manual or at the Servo Tester 2
;       homepage: http://www.ejberg.dk/servotst2


.equ Router_Output1     = 0
.equ Router_Output2     = 1
.equ Router_Input       = 2
.equ Router_InputAvg    = 3
.equ Router_Sweep1      = 4
.equ Router_Sweep2      = 5
.equ Router_Idle        = 6
.equ Router_NotInUse    = 0xff


.dseg

RouterOutputA:  .byte 1
RouterOutputB:  .byte 1

RouterOldA:     .byte 1
RouterOldB:     .byte 1


.cseg

Router_Init:
        ldi     w1,Router_Idle
        sts     RouterOldA,w1
        sts     RouterOldB,w1
        ret


RouterSetOutputA:
        push    w2
        lds     w2,RouterOutputA
        cpse    w1,w2
        rjmp    RSOA_NewOutput
        lds     w2,RouterOldA           ;Output already selected. Revert to previous used output
        sts     RouterOutputA,w2
        sts     RouterOldA,w1
        rjmp    RSOA_Exit
RSOA_NewOutput:
        sts     RouterOutputA,w1
        sts     RouterOldA,w2
RSOA_Exit:
        pop     w2
        ret


RouterSetOutputB:
        push    w2
        lds     w2,RouterOutputB
        cpse    w1,w2
        rjmp    RSOB_NewOutput
        lds     w2,RouterOldB           ;Output already selected. Revert to previous used output
        sts     RouterOutputB,w2
        sts     RouterOldB,w1
        rjmp    RSOB_Exit
RSOB_NewOutput:
        sts     RouterOutputB,w1
        sts     RouterOldB,w2
RSOB_Exit:
        pop     w2
        ret


Router_GetPulse_w12:                    ;Input:  w1=Router ident (called from interrupt)
        cpi     w1,Router_Output1       ;Output: w1=low pulse
        brne    PGP_NotOut1             ;        w2=high pulse
        lds     w1,Output1Value
        lds     w2,Output1Value+1
        ret
PGP_NotOut1:
        cpi     w1,Router_Output2
        brne    PGP_NotOut2
        lds     w1,Output2Value
        lds     w2,Output2Value+1
        ret
PGP_NotOut2:
        cpi     w1,Router_Input
        brne    PGP_NotIn
        lds     w1,PulseInput
        lds     w2,PulseInput+1
        ret
PGP_NotIn:
        cpi     w1,Router_InputAvg
        brne    PGP_NotInAvg
        lds     w1,InputAvgValue
        lds     w2,InputAvgValue+1
        ret
PGP_NotInAvg:
        cpi     w1,Router_Sweep1
        brne    PGP_NotSweep1
        lds     w1,Sweep1Value
        lds     w2,Sweep1Value+1
        ret
PGP_NotSweep1:
        cpi     w1,Router_Sweep2
        brne    PGP_NotSweep2
        lds     w1,Sweep2Value
        lds     w2,Sweep2Value+1
        ret
PGP_NotSweep2:
        cpi     w1,Router_Idle
        brne    PGP_NotIdle
        clr     w1
        clr     w2
        ret
PGP_NotIdle:
        clr     w1
        clr     w2
        ret


