;****** Servo Tester 2
;       Timer include file
;       Timekeeping functions
;
;       Copyright (c) 2004, Mikael Ejberg Pedersen
;       Only for non-profit use. See a more detailed license
;       description in the user manual or at the Servo Tester 2
;       homepage: http://www.ejberg.dk/servotst2


.equ    TC2TopValueLow  =96             ; Close to 10 ms @ Clk/1024

.dseg
Timer100msCounter:      .byte 1
TimerAddTop:            .byte 1

.cseg

Timer_CompareMatch_int:         ; Timer2 Compare Match Handler
        push    w1
        in      w1,SREG
        push    w1
        push    w2
        lds     w1,TimerAddTop
        inc     w1
        cpi     w1,4
        brne    TCM_NotTimeCorrection
        ldi     w1,1
TCM_NotTimeCorrection:
        sts     TimerAddTop,w1
        andi    w1,1
        subi    w1,-TC2TopValueLow      ;Add TC2TopValueLow to w1
        out     OCR2,w1
        call    Rotary_10ms_int_w12
        call    Pulse_10ms_int_w12
        lds     w1,Timer100msCounter
        dec     w1
        sts     Timer100msCounter,w1
        brne    TCM_Not100ms
        ldi     w1,10
        sts     Timer100msCounter,w1
        call    Pulse_100ms_int_w12
        call    Tacho_100ms_int_w12
        ldi     w1,EVENT_TimerTick
        call    EventQ_PutEvent
TCM_Not100ms:
        pop     w2
        pop     w1
        out     SREG,w1
        pop     w1
        ret


Timer_Init:
        ldi     w1,10
        sts     Timer100msCounter,w1
        clr     w1
        out     ASSR,w1
        out     TCNT2,w1
        sts     TimerAddTop,w1
        ldi     w1,(1<<WGM21)+(1<<CS22)+(1<<CS21)+(1<<CS20)
        out     TCCR2,w1                ;Count at Clk/1024 rate
        ldi     w1,TC2TopValueLow
        out     OCR2,w1
        in      w1,TIMSK
        sbr     w1,(1<<OCIE2)
        cbr     w1,(1<<TOIE2)
        out     TIMSK,w1
        ret

